/*
 * MoleculeSelectionDescriptor_impl.hpp
 *
 *  Created on: Jul 16, 2010
 *      Author: crueger
 */

#ifndef MOLECULESELECTIONDESCRIPTOR_IMPL_HPP_
#define MOLECULESELECTIONDESCRIPTOR_IMPL_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include "Descriptors/MoleculeDescriptor_impl.hpp"

class MoleculeSelectionDescriptor_impl : public MoleculeDescriptor_impl{
public:
  MoleculeSelectionDescriptor_impl();
  virtual ~MoleculeSelectionDescriptor_impl();
  bool predicate(const std::pair<moleculeId_t,const molecule*> molecule) const;
protected:
  // need to overide more than the standard methods to make this fast
  virtual molecule *find();
  virtual const molecule *find() const;
  virtual std::vector<molecule*> findAll();
  virtual std::vector<const molecule*> findAll() const;

  World::MoleculeSet& getSelectedMolecules();
  const World::MoleculeSet& getSelectedMolecules() const;
};

#endif /* MOLECULESELECTIONDESCRIPTOR_IMPL_HPP_ */
